qwebirc.ui.GenericLoginBox = function(parentElement, callback, initialNickname, initialChannels, autoConnect, autoNick, networkName, recaptchaKey) {
  if(autoConnect) {
    qwebirc.ui.ConfirmBox(parentElement, callback, initialNickname, initialChannels, autoNick, networkName, recaptchaKey);
  } else {
    qwebirc.ui.LoginBox(parentElement, callback, initialNickname, initialChannels, networkName, recaptchaKey);
  }
}

qwebirc.ui.AuthLogin = function(e) {
  var cookie = Cookie.write("redirect", document.location);
  document.location = qwebirc.global.dynamicBaseURL + "auth/";
  new Event(e).stop();
}

qwebirc.ui._createRecaptcha = function(createRow, key, args) {
  var e = new Element("p", {"class": "qwebirc-recaptcha-incorrect"});
  e.set("text", "The CAPTCHA you have entered is incorrect. Please try again.");
  var recaptchaIncorrectRow = createRow("", e, {display: "none"})[0];

  e = createRow("", new Element("div", {id: "recaptcha_image"}));
  var d1 = e.parentNode.firstChild;
  e = new Element("a", {href: "javascript:Recaptcha.showhelp()"});
  // Yeah yeah, freenode copycat alert...
  e.set("text", "reCAPTCHA:");
  d1.appendChild(e);

  var s = new Element("span");
  s.appendChild(new Element("input", {type: "text",
                                      id: "recaptcha_response_field",
                                      name: "recaptcha_response_field"}));
  e = new Element("input", {type: "button", value: "Refresh"});
  e.addEvent("click", function(e) {
    new Event(e).stop();
    Recaptcha.reload();
  });
  s.appendChild(e);
  createRow("", s);

  e = new Element("input", {type: "checkbox"});
  e.addEvent("click", function(e) {
    if (e.target.checked)
      Recaptcha.switch_type("audio");
    else
      Recaptcha.switch_type("image");
  });
  createRow("Audio CAPTCHA:", e);

  args["theme"] = "custom";
  Recaptcha.create(key, null, args);

  return recaptchaIncorrectRow;
}

qwebirc.ui._verifyRecaptcha = function(callback, recaptchaIncorrectRow, recaptchaKey) {
  var cacheAvoidance = qwebirc.util.randHexString(16);
  var r = new Request.JSON({
    url: qwebirc.global.dynamicBaseURL + "e/r?r=" + cacheAvoidance,
    async: true});
  r.addEvent("complete", function(o) {
    if(!o) {
      // Oh yay, google's end...
      alert("Error sending CAPTCHA/receiving response. Try again later.");
    } else if(o[0]) {
      Recaptcha.destroy();
      callback(o[1]);
    } else {
      recaptchaIncorrectRow.setStyle("display", null);
      Recaptcha.reload();
    }
  });
  var postdata = ("&recaptchaC=" +
                  encodeURIComponent(Recaptcha.get_challenge()) +
                  "&recaptchaR=" +
                  encodeURIComponent(Recaptcha.get_response()) +
                  "&recaptchaS=" +
                  encodeURIComponent(((recaptchaKey)?"yes":"no")));
  r.send(postdata);
}

qwebirc.ui.ConfirmBox = function(parentElement, callback, initialNickname, initialChannels, autoNick, networkName, recaptchaKey) {
  var outerbox = new Element("table");
  outerbox.addClass("qwebirc-centrebox");
  parentElement.appendChild(outerbox);
  var tbody = new Element("tbody");
  outerbox.appendChild(tbody);
  var tr = new Element("tr");
  tbody.appendChild(tr);
  var td = new Element("td");
  tr.appendChild(td);

  var form = new Element("form");
  td.appendChild(form);

  var box = new Element("table");
  box.addClass("qwebirc-confirmbox");
  form.appendChild(box);

  var tbody = new Element("tbody");
  box.appendChild(tbody);

  function createRow(label, e2, style) {
    var r = new Element("tr");
    tbody.appendChild(r);

    var d1 = new Element("td");
    if(label)
      d1.set("text", label);
    r.appendChild(d1);

    var d2 = new Element("td");
    r.appendChild(d2);

    if($defined(e2))
      d2.appendChild(e2);
    if($defined(style)) {
      r.setStyles(style);
      return [r, d2];
    }

    return d2;
  }

  var tr = new Element("tr");
  tbody.appendChild(tr);
  tr.addClass("tr1");
  
  var text = new Element("td", {colspan: "2"});
  tr.appendChild(text);
  
  var nick = new Element("b");
  nick.set("text", initialNickname);
  
  var c = initialChannels.split(" ")[0].split(",");
  
  text.appendChild(document.createTextNode("To connect to " + networkName + " IRC and join channel" + ((c.length>1)?"s":"") + " "));

  for(var i=0;i<c.length;i++) {
    if((c.length > 1) && (i == c.length - 1)) {
      text.appendChild(document.createTextNode(" and "));
    } else if(i > 0) {
      text.appendChild(document.createTextNode(", "));
    }
    text.appendChild(new Element("b").set("text", c[i]));
    
  }
  
  if(!autoNick) {
    text.appendChild(document.createTextNode(" as "));
    text.appendChild(nick);
  }
  
  text.appendChild(document.createTextNode(((recaptchaKey)?" complete the CAPTCHA and click 'Connect'.":" click 'Connect'.")));
  text.appendChild(new Element("br"));
  if(qwebirc.auth.enabled() && qwebirc.auth.quakeNetAuth() && !qwebirc.auth.loggedin())
    text.appendChild(document.createTextNode("If you'd like to connect using your Q auth click 'Log in'."));

  if(recaptchaKey) {
    var recaptchaIncorrectRow = qwebirc.ui._createRecaptcha(
      createRow, recaptchaKey, {callback: Recaptcha.focus_response_field});
  }

  var tr = new Element("tr");
  tbody.appendChild(tr);
  tr.addClass("tr2");
  
  var td;
  if (recaptchaKey) {
    // Align the "connect" button with the rest of the form:
    td = new Element("td");
    tr.appendChild(td);
    td = new Element("td");
    tr.appendChild(td);
  } else {
    // BUGFIX: Wait, so button doesn't exist with captcha off?!
    td = new Element("td", {colspan: "2"});
    td.setStyle("text-align", "center");
    tr.appendChild(td);
  }

  var yes = new Element("input", {"type": "submit", "value": "Connect"});
  td.appendChild(yes);
  function finish(sessionid) {
    parentElement.removeChild(outerbox);
    callback({"nickname": initialNickname, "autojoin": initialChannels,
              "sessionid": sessionid});
  }
  yes.addEvent("click", function(e) {
    // (to prevent the form we are in from actually submitting).
    new Event(e).stop();
    if(!recaptchaKey) {
      finish(null);
    } else {
      qwebirc.ui._verifyRecaptcha(finish, recaptchaIncorrectRow);
    }
  });

  if(qwebirc.auth.enabled() && qwebirc.auth.quakeNetAuth() && !qwebirc.auth.loggedin()) {
    var auth = new Element("input", {"type": "submit", "value": "Log in"});
    td.appendChild(auth);
    auth.addEvent("click", qwebirc.ui.AuthLogin);
  }
  
  if(window == window.top)
    yes.focus();
}

qwebirc.ui.LoginBox = function(parentElement, callback, initialNickname, initialChannels, networkName, recaptchaKey) {
  var outerbox = new Element("table");
  outerbox.addClass("qwebirc-centrebox");
  parentElement.appendChild(outerbox);
  var tbody = new Element("tbody");
  outerbox.appendChild(tbody);
  var tr = new Element("tr");
  tbody.appendChild(tr);
  var td = new Element("td");
  tr.appendChild(td);
  
  var box = new Element("table");
  box.addClass("qwebirc-loginbox");
  td.appendChild(box);
  
  var tbody = new Element("tbody");
  box.appendChild(tbody);
  
  var tr = new Element("tr");
  tbody.appendChild(tr);
  tr.addClass("tr1");
  
  var td = new Element("td");
  tr.appendChild(td);
  td.set("html", "<h1>Connect to " + networkName + " IRC</h1>");  
    
  var tr = new Element("tr");
  tbody.appendChild(tr);
  tr.addClass("tr2");
  
  var td = new Element("td");
  tr.appendChild(td);
  
  var form = new Element("form");
  td.appendChild(form);

  var boxtable = new Element("table");
  form.appendChild(boxtable);

  var tbody = new Element("tbody");
  boxtable.appendChild(tbody); /* stupid IE */

  function createRow(label, e2, style) {
    var r = new Element("tr");
    tbody.appendChild(r);

    var d1 = new Element("td");
    if(label)
      d1.set("text", label);
    r.appendChild(d1);

    var d2 = new Element("td");
    r.appendChild(d2);
    
    if($defined(e2))
      d2.appendChild(e2);
    if($defined(style)) {
      r.setStyles(style);
      return [r, d2];
    }
    
    return d2;
  }

  var nick = new Element("input");
  createRow("Nickname:", nick);
  
  var chanStyle = null;
  if(qwebirc.auth.enabled() && qwebirc.auth.bouncerAuth())
    chanStyle = {display: "none"};
  
  if(initialChannels != "")
    var chan = new Element("input");

  createRow("Channels:", chan, chanStyle);

  if(qwebirc.auth.enabled()) {
    if(qwebirc.auth.passAuth()) {
      var authRow = createRow("Auth to services:");
      var authCheckBox = qwebirc.util.createInput("checkbox", authRow, "connect_auth_to_services", false);
    
      var usernameBox = new Element("input");
      var usernameRow = createRow("Username:", usernameBox, {display: "none"})[0];
    
      var passwordRow = createRow("Password:", null, {display: "none"});
      var passwordBox = qwebirc.util.createInput("password", passwordRow[1], "connect_auth_password");

      authCheckBox.addEvent("click", function(e) { qwebirc.ui.authShowHide(authCheckBox, authRow, usernameBox, usernameRow, passwordRow[0]) });
    } else if(qwebirc.auth.bouncerAuth()) {
      var passwordRow = createRow("Password:");
      var passwordBox = qwebirc.util.createInput("password", passwordRow, "connect_auth_password");
    } else if(qwebirc.auth.nsAuth()) {    
      var passwordRow = createRow("Password:", null, {display: ""});
      var passwordBox = qwebirc.util.createInput("password", passwordRow[1], "ns_auth_password", false);
      passwordBox.addEvent('domready', function(e) { this.disabled = 1; });
      
      var authRow = createRow("Auth:");
      var authCheckBox = qwebirc.util.selectInput(authRow);
      authCheckBox.addEvent('change', function(e) { qwebirc.ui.nsAuthShowHide(authCheckBox, passwordRow[0], passwordBox) }); 
       
    }
  }
  if(recaptchaKey) {
    var recaptchaIncorrectRow = qwebirc.ui._createRecaptcha(
      createRow, recaptchaKey, {});
  }
  
  var connbutton = new Element("input", {"type": "submit"});
  connbutton.set("value", "Connect");
  var r = createRow(undefined, connbutton);
  
  if(qwebirc.auth.enabled() && qwebirc.auth.quakeNetAuth() && !qwebirc.auth.loggedin()) {
    var auth = new Element("input", {"type": "submit", "value": "Log in"});
    r.appendChild(auth);
    auth.addEvent("click", qwebirc.ui.AuthLogin);
  }

  form.addEvent("submit", function(e) {
    new Event(e).stop();
    var nickname = nick.value;
    var chans = chan.value;
    if(chans == "#") /* I'm invalid on Rizon :( */
      chans = "";

    if(!nickname) {
      alert("You must supply a nickname.");
      nick.focus();
      return;
    }
	var stripped = qwebirc.global.nicknameValidator.validate(nickname);
    if(stripped != nickname) {
	  nick.value = stripped;
	  alert("Your nickname was invalid and has been corrected; please check your altered nickname and press Connect again.");
	  nick.focus();
	  return;
	}
	
    var data = {"nickname": nickname, "autojoin": chans};
    if(qwebirc.auth.enabled()) {
      if(qwebirc.auth.passAuth() && authCheckBox.checked) {
          if(!usernameBox.value || !passwordBox.value) {
            alert("You must supply your username and password in auth mode.");
            if(!usernameBox.value) {
              usernameBox.focus();
            } else {
              passwordBox.focus();
            }
            return;
          }
          
          data["serverPassword"] = usernameBox.value + " " + passwordBox.value;
      } else if(qwebirc.auth.bouncerAuth()) {
        if(!passwordBox.value) {
          alert("You must supply a password.");
          passwordBox.focus();
          return;
        }
        
        data["serverPassword"] = passwordBox.value;
      } else if(qwebirc.auth.nsAuth() && authCheckBox.value == "connect_auth_to_service") {
          if(!passwordBox.value) {
            alert("You must supply a NickServ password.");
            passwordBox.focus();
            return;
        }
          
        data["nsPassword"] = passwordBox.value;
      } else if (authCheckBox.value == "auth_to_bncus") {
          if(!passwordBox.value) {
            alert("You must supply a username and password.");
            passwordBox.focus();
            return;
          }
          
        data["bncuspassword"] = passwordBox.value;
      } else if (authCheckBox.value == "auth_to_bnceu") {
          if(!passwordBox.value) {
            alert("You must supply a username and password.");
            passwordBox.value();
            return;
          }
          
        data["bnceupassword"] = passwordBox.value;  
      }
    }
    function finish(sessionid) {
      if(sessionid)
        data["sessionid"] = sessionid;
      parentElement.removeChild(outerbox);

      callback(data);
    }

    if(!recaptchaKey) {
      finish(null);
    } else {
      qwebirc.ui._verifyRecaptcha(finish, recaptchaIncorrectRow);
    }
  }.bind(this));
    
  nick.set("value", initialNickname);
  chan.set("value", initialChannels);

  if(window == window.top)
    nick.focus();
}

qwebirc.ui.authShowHide = function(checkbox, authRow, usernameBox, usernameRow, passwordRow) {
  var visible = checkbox.checked;
  var display = visible?null:"none";
  usernameRow.setStyle("display", display);
  passwordRow.setStyle("display", display);
  
  if(visible) {
//    authRow.parentNode.setStyle("display", "none");
    usernameBox.focus();
  }
}

qwebirc.ui.nsAuthShowHide = function(authCheckBox, passwordRow, passwordBox) {
 var visible = authCheckBox.value;
  if(visible != "None") {
    passwordBox.disabled = 0;
    passwordBox.value = "";
    passwordBox.focus();
   }
   else {
    passwordBox.value = "";
    passwordBox.disabled = 1;
   }
}
